requirejs.config({
	paths: {
		"d3": [
			'http://d3js.org/d3.v3.min',
			'lib/d3.v3.min'
		]
	}
});

require(["visual/Grid"],
	function(Grid){
		var App = function(){
			this.param = {};
			this.grid = null;
		};
		var proto = App.prototype;

		proto.run = function(){
			var startX = 3, startY = 3,
				i, algo;
			this._updateParam();

			for(i=0; i<this.param.algos.length; i++){
				algo = this.param.algos[i];
				this.grid.drawTextLine(algo + "_text", this.param.text, startX, startY+3*i);
				this.grid.drawTextLine(algo + "_word", this.param.word, startX, startY+3*i+1);
			}
		};

		proto._updateParam = function(){
			var paramForm = document.getElementById("paramForm"),
				i, algoCb;
			this.param.text = paramForm.elements.text.value;
			this.param.word = paramForm.elements.word.value;
			this.param.algos = [];
			for(i=0; i< paramForm.elements.algos.length; i++){
				algoCb = paramForm.elements.algos[i];
				if(algoCb.checked){
					this.param.algos.push(algoCb.value);
				}
			};
		};

		proto.init = function(){
			var self = this;
			this.grid = new Grid("#panel", {
				rowNum: 10,
				colNum: 30,
				nodeSize: 30
			});
			this.grid.init();

			// var i = 0;
			// setInterval(function(){
			// 	grid.textLines["a string"].moveRight(1);

			// 	if(i<7){
			// 		grid.textLines["a string"].markMatched(i);
			// 		i++;
			// 	}
			// }, 2000);

			d3.select("#searchBtn").on("click", function(){
				self.run();
			});
		};
		
		var app = new App();
		app.init();
	}
);